
#ifndef TESTRENDERTHREAD_H
#define TESTRENDERTHREAD_H


// Qt Headers
#pragma warning(push, 1)
#include <QtGlobal>
#include <QThread>
#pragma warning(pop)


// Forward Declarations
class QEvent;
class QOpenGLContext;
class QOpenGLShaderProgram;
class QOpenGLWindow;



// Forward Declarations
class QEvent;



class tTestRenderThread: public QThread
{
	Q_OBJECT

public: 
    tTestRenderThread(QOpenGLWindow* pRenderTarget);

    ~tTestRenderThread();


protected:
    //------- Inherited from QThread --------//
    void run();

    void customEvent(QEvent* pEvent);


private slots:
	void RenderScene();


private:
	void InitializeContext();
    void Initialize();

    QOpenGLWindow* m_pRenderTarget;
    QOpenGLContext* m_pContext;

	bool m_Initialize;

#if (defined Q_WS_QPA && !defined QT_OPENGL_ES_1) || defined QT_OPENGL_ES_2 || QTOPENGL_VERSION >= 2 || defined Q_OS_WIN32

    QOpenGLShaderProgram* m_pShaderProgram;

    int vertexAL;
    int colorAL;
    int matrixUL;

#endif
};






#endif  // TESTRENDERTHREAD_H



