
#include "TestWidget.h"

#include <QApplication>
#include <QDebug>

#include "TestRenderThread.h"


/***************************************************************************/

tTestWidget::tTestWidget(QWindow* pWindow)
    : QOpenGLWindow(QOpenGLWindow::NoPartialUpdate, pWindow)
    , m_pRenderThread(0)
{
    doneCurrent();
}

/***************************************************************************/

tTestWidget::~tTestWidget()
{
}

/***************************************************************************/

void tTestWidget::paintEvent(QPaintEvent* pEvent)
{
	qDebug("Paint Event");

    RenderScene();
}

/***************************************************************************/

void tTestWidget::resizeEvent(QResizeEvent* pEvent)
{
    RenderScene();
}

/***************************************************************************/

void tTestWidget::CreateRenderThread()
{
	m_pRenderThread = new tTestRenderThread(this);
    m_pRenderThread->moveToThread(m_pRenderThread);
	m_pRenderThread->start();
}

/***************************************************************************/

void tTestWidget::RenderScene()
{
	if (m_pRenderThread == 0)
	{
        CreateRenderThread();
	}

    QEvent* pRenderEvent = new QEvent(QEvent::User);
	QCoreApplication::postEvent(m_pRenderThread, pRenderEvent);
}

/***************************************************************************/




